! This file is part of MoRe-SusHi.
! 
! It includes the input and output routines of MoRe-SusHi.
! 
C-{{{ subroutine outputmoresushi

      subroutine outputmoresushi()

      implicit none

      logical fhflag,thdmcflag
      integer i
      double precision delmb, gghnnloout(-1:5), gghnnloout2(-1:5)
      double precision effres, res, effres2
      character resstring*30, effresstring*30
      character effresstring2*30,bbhstring*3
      integer date_time(8)
      character realcl(3)*12

c$$$      include '../commons/common-inputoutput.f'
      !internal definitions
!defined at other places:
!AlfasMZ,muRfactor,muFfactor,cme,dist,prefix,prefix2,pty,iset
!norderggh,mw,mc,ew,mz,mbmb,renscheme,mt,pseudo,tanbresum,pseudorap
      include 'Commons/common-sushi.f'
      include 'Commons/common-pdfvals.f'
      include 'Commons/common-order.f'
      include 'Commons/common-output.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-chankeys.f'
      include 'Commons/common-scalesintvars.f'

c$$$      common /bveg1/ xl,xu,acc,ndm,ncall,itmx,nprn

      fhflag = fhkey
      thdmcflag = .false.
      delmb = 0.d0

      open(unit=13,file=paramfile,status='unknown')

c$$$      bbhstring = 'bbh'
c$$$      if (lcchkey) bbhstring = 'cch'

      call printcopymoresushi(0,13,verbosept)

      call date_and_time(realcl(1),realcl(2),realcl(3),date_time)

      write (13,106) date_time(3), date_time(2), date_time(1),
     &date_time(5), date_time(6), date_time(7)

      write(13,103)
     &"# For the reconstructed input file, check below.   #"
      write(13,103)
     &"#--------------------------------------------------#"
c$$$      if ((ew.eq.1).and.(norderggh.ge.1)) then
c$$$         citations(11) = 1
c$$$         citations(12) = 1
c$$$      endif
c$$$      if ((ew.eq.2).and.(norderggh.ge.1).and.
c$$$     &((dist.eq.0).and.(rapc.eq.0).and.(ptc.eq.0))) then
c$$$         citations(10) = 1
c$$$      endif
c$$$      if(norderggh.ge.1) then
c$$$      endif
      citations(26) = 1
      citations(20) = 2
      citations(21) = 2
      citations(22) = 2

      citations(94) = 1
      citations(95) = 1
      citations(96) = 1
      citations(97) = 1
      citations(98) = 1
      citations(99) = 1
      write(13,"(a)")
     &"# Please cite the following papers (for this run):"
      call printcitept(13,1,'# ')
      write(13,103)
     &"#--------------------------------------------------#"

      write(13,103) 'Block MORESUSHIinfo'
      write(13,1023) 1,version,  'MoRe-SusHi version'
      write(13,1023) 2,SUversion,'SusHi version'
      !detailled output
      !SM ggh
      write(13,102)  3,elw,"electroweak factor"
      !effective couplings in MSSM
      if (model.ge.1) then
         if (pseudo.eq.0) then
            write(13,103) 
     &"Block HGGSUSY # couplings of light Higgs h to 3. generation"
         else if (pseudo.eq.1) then
            write(13,103) 
     &"Block HGGSUSY # couplings of pseudoscalar A to 3. generation"
         else if (pseudo.eq.2) then
            write(13,103) 
     &"Block HGGSUSY # couplings of heavy Higgs H to 3. generation"
         end if
         write(13,102) 101,gt3,'g_t^phi'
         if (model.eq.1) then
            write(13,102) 111,gt13,'g_st11^phi'
            write(13,102) 122,gt23,'g_st22^phi'
            write(13,102) 112,gth123,'g_st12^phi'
            write(13,102) 121,gth213,'g_st21^phi'
         end if
         write(13,102) 201,gb3,'g_b^phi'
         if (model.eq.1) then
            write(13,102) 211,gb13,'g_sb11^phi'
            write(13,102) 222,gb23,'g_sb22^phi'
            write(13,102) 212,gbh123,'g_sb12^phi'
            write(13,102) 221,gbh213,'g_sb21^phi'
         end if
         if((yukfac(4).ne.0.d0).or.(yukfac(5).ne.0.d0)) then
            if (pseudo.eq.0) then
               write(13,103) 
     &"Block HGGSUSY4 # couplings of light Higgs h to 4. generation"
            else if (pseudo.eq.1) then
               write(13,103) 
     &"Block HGGSUSY4 # couplings of pseudoscalar A to 4. generation"
            else if (pseudo.eq.2) then
               write(13,103) 
     &"Block HGGSUSY4 # couplings of heavy Higgs H to 4. generation"
            end if
            write(13,102) 101,gt4,'g_t^phi'
            if (model.eq.1) then
            write(13,102) 111,gt14,'g_st11^phi'
            write(13,102) 122,gt24,'g_st22^phi'
            write(13,102) 112,gth124,'g_st12^phi'
            write(13,102) 121,gth214,'g_st21^phi'
            end if
            write(13,102) 201,gb4,'g_b^phi'
            if (model.eq.1) then
            write(13,102) 211,gb14,'g_sb11^phi'
            write(13,102) 222,gb24,'g_sb22^phi'
            write(13,102) 212,gbh124,'g_sb12^phi'
            write(13,102) 221,gbh214,'g_sb21^phi'
            end if
         endif
      endif
      !additional output
! --------------------------------------
      write(13,103) 'Block MASSOUT'
      write(13,102) 1,Mh,'Mphi in GeV'
      write(13,102) 4,mcmc,'m_c(m_c), MSbar'
      write(13,102) 5,mbmb,'m_b(m_b), MSbar'
      write(13,102) 6,mt,'m_t(pole)'
      write(13,102) 23,mZ,'m_Z'
      write(13,102) 24,mW,'m_W'
      if (pseudo.eq.0) then
         write(13,102) 25,Mh,'Mh in GeV'
      elseif (pseudo.eq.1) then
         write(13,102) 36,Mh,'MA in GeV'
      elseif (pseudo.eq.2) then
         write(13,102) 35,Mh,'MH in GeV'
      endif
! --------------------------------------
      if (model.eq.1) then
         write(13,102) 1000005,Msbot1,'sbottom1 mass in GeV'
         write(13,102) 2000005,Msbot2,'sbottom2 mass in GeV'
         write(13,102) 1000006,Mstop1,'stop1 mass in GeV'
         write(13,102) 2000006,Mstop2,'stop2 mass in GeV'
         write(13,102) 1000021,Mgl,'gluino mass in GeV'
      end if

      if ((model.eq.2).and.(thdmcflag)) then
         write(13,103) 'Block 2HDMCOUT # 2HDMC results for'
         write(13,1020) 1,int(thdmcres(7))
     &        ,'stability, 0=failed, 1=ok'
         write(13,1020) 2,int(thdmcres(8)),
     &        'perturbativity, 0=failed, 1=ok'
         write(13,1020) 3,int(thdmcres(9))
     &        ,'unitarity, 0=failed, 1=ok'
      end if
      if ((model.eq.1).and.(fhflag)) then
         write(13,103) 'Block ALPHA # Higgs mixing parameter from FH'
         write(13,107) alpha,'alpha'
      end if

      if (model.eq.1) then
         write(13,103) 'Block STOPMIX # stop mixing matrix'
         write(13,108) 1,1,cthetat,'V_11'
         write(13,108) 1,2,sthetat,'V_12'
         write(13,108) 2,1,-sthetat,'V_21'
         write(13,108) 2,2,cthetat,'V_22'
         write(13,103) 'Block SBOTMIX # sbottom mixing matrix'
         write(13,108) 1,1,cthetab,'V_11'
         write(13,108) 1,2,sthetab,'V_12'
         write(13,108) 2,1,-sthetab,'V_21'
         write(13,108) 2,2,cthetab,'V_22'
         write(13,103) 'Block AD'
         write(13,108) 3,3,Ab
     &        ,'used Ab in GeV - def. accord. to scheme'
         write(13,103) 'Block AU'
         write(13,108) 3,3,At,'used At in GeV'
      endif
      
      write(13,103) 'Block INTERNALMASSES # Masses in GeV'
! --------------------------------------
      write(13,102) 40,mcos,'m_c(pole)'
      write(13,102) 50,mbmb,'m_b(m_b), MSbar'
      write(13,102) 51,mbMSbarmuR ,'m_b(mu_R) MSbar'
      write(13,102) 52,mbOS       ,'m_b(pole)'
      write(13,102) 53,mb
! --------------------------------------
     &     ,'m_b used for internal masses'
      if (tanbresum.eq.1) then
         write(13,102) 54,mbyuk/(1+delmb)
     &        ,'m_b for bottom Yukawa'
      else if (tanbresum.eq.2) then
         if (pseudo.eq.1) then
            write(13,102) 54,mbyuk* (1.d0 - (1.d0/tanb
     &           **2)*delmb)* (1.d0/(1.d0+delmb))
     &           ,'m_b for bottom Yukawa'
         else if (pseudo.eq.0) then
            write(13,102) 54,mbyuk* (1.d0 - (1.d0/(tanb
     &           *Tan(alpha)))*delmb)* (1.d0/(1.d0
     &           +delmb)),'m_b for bottom Yukawa'
         else if (pseudo.eq.2) then
            write(13,102) 54,mbyuk* (1.d0 + (Tan(alpha)
     &           /tanb)*delmb)* (1.d0/(1.d0+delmb))
     &           ,'m_b for bottom Yukawa'
         end if 
      else
         write(13,102) 54,mbyuk
     &           ,'m_b for bottom Yukawa'
      endif
      if (model.eq.1) then
         write(13,102) 55,mbsb     ,'m_b for sbottom sector'
      endif
! --------------------------------------
c$$$      write(13,103) 'Block ALPHASOUT # values from LHAPDF set'
c$$$      if (scalespt) then
c$$$         if (norderggh.ge.1) then
c$$$            write(13,102) 2,awithpt,
c$$$     &           'alpha_s(muR)@NLO'
c$$$            write(13,102) 20,awopt,
c$$$     &           'alpha_s(muR(w/o)pt)@NLO'
c$$$         endif
c$$$      else
c$$$         if (norderggh.eq.0) then
c$$$            write(13,102) 1,alphamur,'alpha_s(muR)@LO'
c$$$         endif
c$$$         if (norderggh.ge.1) then
c$$$            write(13,102) 2,alphamur,'alpha_s(muR)@NLO in ggh'
c$$$         endif
c$$$         if (norderbbh.ge.0) then
c$$$            write(13,102) 11,apimurbbh*pi,'alpha_s(muR) in '//bbhstring
c$$$         endif
c$$$         
c$$$         if (.not.((dist.ge.1).or.(ptcut).or.(rapcut))) then
c$$$            if (norderggh.ge.2) then
c$$$               write(13,102) 3,apimur*pi,'alpha_s(muR)@NNLO'
c$$$            end if
c$$$         end if
c$$$         
c$$$      end if
! --------------------------------------
      
      write(13,103)
     &     "#--------------------------------------------------#"
      write(13,103)
     &     "# Reconstructed input file of this run             #"
      write(13,103)
     &     "#--------------------------------------------------#"
      
!Reproduction of the input file
      write(13,103) 'Block MORESUSHI'
      write(13,1031) 1,N,'Number of integrations'
      write(13,103) 'Block DISTRIB2'
      write(13,102)  1,pT_Hmin,'Minimal Higgs pT in GeV'
      write(13,102)  2,pT_Hmax,'Maximal Higgs pT in GeV'
      write(13,102)  5,stepsize,'Stepsize of Higgs pT in GeV'
      write(13,103) 'Block MORESUSHIKEYS'
      write(13,1020) 1,ggkey,'gluon-gluon channel: 0=off, 1=on'
      write(13,1020) 2,gqkey,'gluon-quark channel: 0=off, 1=on'
      write(13,1020) 3,qqkey,'quark-quark channel: 0=off, 1=on'
      write(13,1020) 11,htlkey,'heavy-top approximation: 0=off, 1=on'
      write(13,103) 'Block SUSHI'
      write(13,1020) 1,model,'Chosen model: 0=SM, 1=MSSM, 2=2HDM'
      write(13,1020) 2,pseudo,'Chosen Higgs particle: 0=h, 1=A, 2=H'
      if (pp.eq.1) then
         write(13,1020) 3,0,'Particle collider: 0=pp, 1=ppbar'
      else
         write(13,1020) 3,1,'Particle collider: 0=pp, 1=ppbar'
      end if
      write(13,102)  4,dsqrt(Shad),'center-of-mass energy in GeV'
c$$$      write(13,1020) 5,norderggh,'Order for ggh'
c$$$      if (lcchkey) then
c$$$         write(13,1020) 6,norderbbh+10,'Order for '//bbhstring//'+10'
c$$$      else
c$$$         write(13,1020) 6,norderbbh,'Order for '//bbhstring
c$$$      endif
      write(13,1020) 7,ewswitch,'Electroweak contributions to ggh'
c$$$      write(13,1020) 19,verbosept
c$$$     &     ,'0 = silent mode of MoRe-SusHi, 1 = normal output'
      if ((model.eq.2).and.(thdmcflag.eqv.(.false.))) then
         write(13,103) 'Block 2HDM'
         write(13,1070) twohdmver,'2HDM type'
      end if
      if (thdmcflag) then
         write(13,103) 'Block 2HDMC'
         write(13,1020) 1,thdmckey,'parametrization of 2HDM'
         write(13,1020) 2,twohdmver,'2HDM type'
         write(13,1020) 10,thdmcbreak
     &        ,'[1/0] do /not ignore validity checks'
         if (thdmckey.eq.1) then
            write(13,102) 3,tanb,'tan(beta)'
            write(13,102) 4,thdmcm12,'m12'
            write(13,102) 11,tparam(1),'lambda1'
            write(13,102) 12,tparam(2),'lambda2'
            write(13,102) 13,tparam(3),'lambda3'
            write(13,102) 14,tparam(4),'lambda4'
            write(13,102) 15,tparam(5),'lambda5'
            write(13,102) 16,tparam(6),'lambda6'
            write(13,102) 17,tparam(7),'lambda7'
         else if (thdmckey.eq.2) then
            write(13,102) 3,tanb,'tan(beta)'
            write(13,102) 4,thdmcm12,'m12'
            write(13,102) 21,tparam(1),'mh'
            write(13,102) 22,tparam(2),'mH'
            write(13,102) 23,tparam(3),'mA'
            write(13,102) 24,tparam(4),'mC'
            write(13,102) 25,tparam(5),'sin(beta-alpha)'
            write(13,102) 26,tparam(6),'lambda6'
            write(13,102) 27,tparam(7),'lambda7'
         else if (thdmckey.eq.3) then
            write(13,102) 3,tanb,'tan(beta)'
            write(13,102) 31,tparam(1),'mh'
            write(13,102) 32,tparam(2),'mH'
            write(13,102) 33,tparam(3),'sin(beta-alpha)'
            write(13,102) 34,tparam(5),'Z4'
            write(13,102) 35,tparam(6),'Z5'
            write(13,102) 36,tparam(7),'Z7'
         else
            call printstop('thdmckey not implemented')
         endif
      endif
      write(13,103) 'Block SMINPUTS'
      write(13,102) 1,invAlfa,'1/alpha_em(MZ) SM MSbar'
       write(13,102) 2,GF,'G_F'
       write(13,102) 3,AlfasMZ,'alpha_s(m_Z)'
       write(13,102) 4,mZ,'m_Z(pole)'
       write(13,102) 5,mbmb,'m_b(m_b)'
       write(13,102) 6,mt,'m_t(pole)' !from more-sushi
       if (yukfac(1).ne.(0.d0)) write(13,102) 8,mcmc,'m_c(m_c)'
      if (((model.eq.2).and.(thdmcflag.eqv.(.false.))).or.
     &(model.eq.1)) then
      write(13,103) 'Block MINPAR'
       write(13,102) 3,tanb,'tan(beta)'
      end if
      !Specific SUSY parameters
      if (model.eq.1) then
      write(13,103) 'Block EXTPAR'
       write(13,102) 3,mgl,'Gluino mass'
       write(13,102) 11,Real(cAt),'A_t'
       write(13,102) 12,Real(cAb),'A_b'
       write(13,102) 23,muSUSY,'mu'
       if (fhflag) write(13,102) 26,mA0,'mA'
       write(13,102) 43,M3SQ,'M3SQ'
       write(13,102) 46,M3SU,'M3SU'
       write(13,102) 49,M3SD,'M3SD'
      if (fhflag) then
      write(13,103) 'Block FEYNHIGGS'
       write(13,102) 1,Real(M_1),'M1'
       write(13,102) 2,Real(M_2),'M2'
       write(13,102) 13,Real(cAtau),'A_tau'
       write(13,102) 14,Real(cAc),'A_c'
       write(13,102) 15,Real(cAs),'A_s'
       write(13,102) 16,Real(cAmu),'A_mu'
       write(13,102) 17,Real(cAu),'A_u'
       write(13,102) 18,Real(cAd),'A_d'
       write(13,102) 19,Real(cAe),'A_e'
       write(13,102) 31,M1SL,'M1SL'
       write(13,102) 32,M2SL,'M2SL'
       write(13,102) 33,M3SL,'M3SL'
       write(13,102) 34,M1SE,'M1SE'
       write(13,102) 35,M2SE,'M2SE'
       write(13,102) 36,M3SE,'M3SE'
       write(13,102) 41,M1SQ,'M1SQ'
       write(13,102) 42,M2SQ,'M2SQ'
       write(13,102) 44,M1SU,'M1SU'
       write(13,102) 45,M2SU,'M2SU'
       write(13,102) 47,M1SD,'M1SD'
       write(13,102) 48,M2SD,'M2SD'
      end if
      end if
      if (((model.eq.2).and.(thdmcflag.eqv.(.false.))).or.
     &((model.eq.1).and.(fhflag.eqv.(.false.)))) then
       write(13,103) 'Block ALPHA # Higgs mixing parameter'
       write(13,107) alpha,'alpha'
      end if
      if (model.eq.0) then
      write(13,103) 'Block MASS'
       write(13,102) 25,Hmass,'Higgs mass' !from more-sushi
      end if
      if (((model.eq.2).and.(thdmcflag.eqv.(.false.))).or.
     &((model.eq.1).and.(fhflag.eqv.(.false.)))) then
      write(13,103) 'Block MASS'
        if(pseudo.eq.0) write(13,102) 25,Hmass,'Light Higgs mass'
        if(pseudo.eq.1) write(13,102) 36,Hmass,'Pseudoscalar Higgs mass'
        if(pseudo.eq.2) write(13,102) 35,Hmass,'Heavy Higgs mass'
      end if
      !only write relevant DISTRIBUTION input

      write(13,103) 'Block SCALES'
      if (runscale.eq.1) then
         write(13,102) 1,muRen/Hmass, !from more-sushi
     &        'Renormalization scale muR/Sqrt(mh^2+pt^2)'
         write(13,102) 2,muF/Hmass, !from more-sushi
     &        'Factorization scale muF/Sqrt(mh^2+pt^2)'
         write(13,1020) 3,1,'Use p_t dependent scale choice'
         write(13,102) 4,Qres,'Resummation scale Qres in GeV'
      else
         write(13,102) 1,muRen/Hmass,'Renormalization scale muR/mh'
         write(13,102) 2,muF/Hmass,'Factorization scale muF/mh'
         write(13,1020) 3,0,'Use p_t dependent scale choice'
         write(13,102) 4,Qres,'Resummation scale Qres in GeV'
c$$$         write(13,102) 11,murfacbbh
c$$$     &        ,'Renormalization scale muR/mh for '//bbhstring
c$$$         write(13,102) 12,muffacbbh,'Factorization scale muF/mh for '
c$$$     &        //bbhstring
      end if
      write(13,103) 'Block RENORMBOT'
       write(13,1020) 1,mbrunyuk,'mb used for bottom Yukawa'
      if (model.eq.1) then
       write(13,1020) 2,tanbresum,'Resummation of sbottom effects'
       write(13,1020) 3,delmbfh,'Delta_b from FeynHiggs'
      end if
      if (mbossave.gt.0.D0)
     &write(13,102) 4,mbossave,'Fixed m_b(pole) in GeV'
      if (model.eq.1) then
      write(13,103) 'Block RENORMSBOT'
       write(13,1020) 1,mbsbch,'Renormalization of m_b'
       write(13,1020) 2,Abch,'Renormalization of A_b'
       write(13,1020) 3,thetabch,'Renormalization of theta_b'
      end if
      write(13,103) 'Block PDFSPEC'
       write(13,1022) 1,prefixLO,'LO   PDF set' !from more-sushi
!       write(13,1020) 11,isetLO,'LO PDF set number'
       write(13,1022) 2,prefixNLO,'NLO  PDF set' !from more-sushi
!       write(13,1020) 12,isetNLO,'NLO PDF set number'
       write(13,1022) 3,prefixNNLO,'NNLO PDF set' !from more-sushi
!       write(13,1020) 13,isetNNLO,'NNLO PDF set number'
       write(13,1020) 4,iset,'PDF set number' !from more-sushi
      write(13,103) 'Block FACTORS'
       write(13,102) 1,yukfac(1),
     &'Factor multiplied with Yukawa of c quark'
       write(13,102) 2,yukfac(2),'t quark'
       write(13,102) 3,yukfac(3),'b quark'
       if (model.eq.1) then
       write(13,102) 4,yukfac(6),'top squark'
       write(13,102) 5,yukfac(7),'bottom squark'
       end if

      !call filedump(12,13)
      write(13,103)
     &"#--------------------------------------------------#"
      write(13,103) 
     &"# End of MoRe-SusHi output                           #"
      write(13,103)
     &"#--------------------------------------------------#"

      close(12)
      close(13)

 102  format(1x,I9,3x,1P,E16.8,0P,3x,'#',1x,A)
 1020 format(1x,I9,3x,1P,i2.1,0P,3x,'#',1x,A)
 1021 format(1x,I9,3x,1P,i6.1,0P,3x,'#',1x,A)
 1031 format(1x,I9,3x,1P,i8.1,0P,3x,'#',1x,A)
 1022 format(1x,I9,3x,1P,A45,0P,3x,'#',1x,A)
 1023 format(1x,I9,3x,1P,A10,0P,3x,'#',1x,A)
 103  format(a)
 105  format('#--------------------------------------------------#')
 106  format ('# Date: ',i2.2,'.',i2.2,'.',i4.4,' at ',
     &i2.2,':',i2.2,':',i2.2,'                     #')
 107  format(9x,1P,E16.8,0P,3x,'#',1x,A)
 1070 format(9x,1P,i2.1,0P,3x,'#',1x,A)
 108  format(1x,I2,1x,I2,3x,1P,E16.8,0P,3x,'#',1x,A)

      end

C-}}}
C-{{{ subroutine printcopymoresushi:

      subroutine printcopymoresushi(fullflag,iu,verbose_local)

      integer fullflag, iu, verbose_local

      include 'Commons/common-output.f'

      if (verbose_local.ne.0) then
         write(iu,1)
     &"#--------------------------------------------------#"
         write(iu,1)
     &"# MoRe-SusHi: Resummed transverse momentum         #"
         write(iu,1)
     &"# distributions of supersymmetric Higgs bosons     #"
         write(iu,1)
     &"#      _  _   __   _   _      __      __           #"
         write(iu,1)
     &"#     | \/ | |  | |_| |_  _  [_  | | [_  |_| |     #"
         write(iu,1)
     &"#     |    | |__| | \ |_     __] |_| __] | | |     #"
         write(iu,1)
     &"#                                                  #"
         write(iu,1)
     &"# Mo(mentum) Re(summed) Su(per)s(ymmetric) Hi(ggs) #"
!         write(iu,1)
!     &"#                                                  #"
         write(iu,1)
     &"# Version "//version//date
     &//"                    #"
         if (fullflag.eq.1) then
            write(iu,1)
     &"# H. Mantler                    (hmantler@cern.ch) #"
            write(iu,1)
     &"# M. Wiesemann            (dr.wiesemann@gmail.com) #"
            write(iu,1)
     &"#--------------------------------------------------#"
            write(iu,1)
     &"# MoRe-SusHi is based on a number of calculations  #"
            write(iu,1)
     &"# due to various groups. Please acknowledge these  #"
            write(iu,1)
     &"# efforts by citing the list of references which   #"
            write(iu,1)
     &"# are included in the output file of every run.    #"
         end if
         write(iu,1)
     &"#--------------------------------------------------#"
      endif

 1    format(a)
      end

C-}}}
C-{{{ SUBROUTINE ParameterOUTandERR:

      SUBROUTINE ParameterOUTandERR()
      implicit none
      DOUBLE PRECISION dsqrtS_had2
      CHARACTER tmp1*2,tmp2*2,tmp3*14,tmp4*7,tmp5*7,tmp6*13,tmp7*13
      include 'Commons/common-output.f'
      include 'Commons/common-order.f'
      include 'Commons/common-cplngs.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-pdfvals.f'
      include 'Commons/common-results.f'
      include 'Commons/common-chankeys.f'

      if(verbosept.ne.0) then
c$$$      IF(htlkey == 0) THEN
c$$$      write(*,*) '                >>>  '//
c$$$     f   '(exact top mass dependence)  <<<         '
c$$$      write(40,*)'                >>>  '//
c$$$     f   '(exact top mass dependence)  <<<         '
c$$$      ELSEIF(htlkey == 1) THEN
c$$$      write(*,*) '                >>> '//
c$$$     f   ' ( heavy-top approximation )  <<<         '
c$$$      write(40,*)'                >>> '//
c$$$     f   ' ( heavy-top approximation )  <<<         '
c$$$      ELSE
c$$$         write(tmp1,'(i2)') order
c$$$         CALL printstop('bad parameter: "order = '//tmp1//'" not '
c$$$     f    //'accepted value')
c$$$      ENDIF
      write(*,*) ' '
      write(40,*)' '

 3333 FORMAT(A25,F8.2,A)
 3332 FORMAT(A25,1X,A7)
 2222 FORMAT(A25,F7.2)
 2221 FORMAT(A25,2X,I2.2)
 2223 FORMAT(A25,I8)
      write(*,*) '         ---====    Parameter    ====---'
      write(40,*)'         ---====    Parameter    ====---'
      dsqrtS_had2=dsqrt(Shad)/1000d0
      write (*, 3333) '-\|S_had`= ', dsqrtS_had2, ' TeV'
      write (*, 3333) 'm_H      = ', Hmass, ' GeV'
      write (*, 3333) 'mu_F     = ', muF, ' GeV'
      write (*, 3333) 'mu_R     = ', muRen, ' GeV'
      write (*, 3333) 'Q_res    = ', Qres, ' GeV'
      write (*, 2221) 'PDF-Set  = ', iset
      write(40, 3333) '-\|S_had`= ', dsqrtS_had2, ' TeV'
      write(40, 3333) 'm_H      = ', Hmass, ' GeV'
      write(40, 3333) 'mu_F     = ', muF, ' GeV'
      write(40, 3333) 'mu_R     = ', muRen, ' GeV'
      write(40, 3333) 'Q_res    = ', Qres, ' GeV'
      write(40, 2221) 'PDF-Set  = ', iset
c$$$      IF(pTH .ne. 0d0) THEN
c$$$         write (*, 3333) 'pT_H        = ', pTH, ' GeV'
c$$$         write (40, 3333) 'pT_H        = ', pTH, ' GeV'
c$$$      ENDIF
      write (*, 2223) 'N_int    = ', N
      write(40, 2223) 'N_int    = ', N

      write(*,*) '         ---====   pT - binning  ====---'
      write(40,*)'         ---====   pT - binning  ====---'

      IF(pT_Hmin > pT_Hmax) THEN
         CALL printstop('bad cuts: pT_Hmin > pT_Hmax not possible'
     f   //'            choose: pT_Hmin < pT_Hmax' )
      ENDIF
      IF(y_Hmin > y_Hmax) THEN
         CALL printstop('bad cuts: y_Hmin > y_Hmax not possible'
     f   //'              choose: y_Hmin < y_Hmax' )
      ENDIF
      IF(pT_Hmin > dsqrt(Shad)/2d0*(1-Hmass**2/Shad)) THEN
         write(tmp3,'(F9.2,A5)') pT_Hmin,' GeV"'
         write(tmp4,'(F7.2)') dsqrt(Shad)/2d0*(1-Hmass**2/Shad)
      CALL printstop('bad cut: "pT_Hmin ='//tmp3//
     f ' cuts everything,  choose: "pT_Hmin < '//tmp4//' GeV" for' 
     f //' used m_H,S_had')
      ENDIF
      IF(pT_Hmax < 0d0) THEN
         write(tmp3,'(F9.2,A5)') pT_Hmax,' GeV"'
      CALL printstop('bad cut: "pT_Hmax ='//tmp3//
     f ' cuts everything,  choose: "pT_Hmax > 0.00 GeV"')
      ENDIF
      IF(y_Hmin > dlog(dsqrt(Shad)/Hmass)) THEN
         write(tmp4,'(F6.2,A1)') y_Hmin,'"' 
         write(tmp5,'(F6.2,A1)') dlog(dsqrt(Shad)/Hmass),'"'
      CALL printstop('bad cut: "y_Hmin ='//tmp4//
     f ' cuts everything,          choose: "y_Hmin <'//tmp5//' for' 
     f //' used m_H,S_had')
      ENDIF
      IF(y_Hmax < -dlog(dsqrt(Shad)/Hmass)) THEN
         write(tmp4,'(F6.2,A1)') y_Hmax,'"' 
         write(tmp5,'(F6.2,A1)') -dlog(dsqrt(Shad)/Hmass),'"'
      CALL printstop('bad cut: "y_Hmax ='//tmp4//
     f ' cuts everything,          choose: "y_Hmax >'//tmp5//' for' 
     f //' used m_H,S_had')
      ENDIF
      IF(bins) THEN
      IF(pT_Hmin > 0d0) THEN
         write (*, 3333) 'pT_Hmin  = ', pT_Hmin, ' GeV'
         write(40, 3333) 'pT_Hmin  = ', pT_Hmin, ' GeV'
      ENDIF
      IF(pT_Hmax < dsqrt(Shad)/2d0*(1-Hmass**2/Shad)) THEN
         write (*, 3333) 'pT_Hmax  = ', pT_Hmax, ' GeV'
         write(40, 3333) 'pT_Hmax  = ', pT_Hmax, ' GeV'
      ENDIF
      IF(stepsize > 0d0) THEN
         write (*, 3333) 'stepsize = ', stepsize, ' GeV'
         write(40, 3333) 'stepsize = ', stepsize, ' GeV'
      ENDIF
      ELSE
      write(*,*) 'no pT - binning'
      write(40,*)'no pT - binning'
      ENDIF
      endif

      write(*,*) ' '
      write(40,*) ' '
      write(*,*)  '      >>>       Start calculation       '//
     f'<<<'
      write(40,*) '      >>>       Start calculation       '//
     f'<<<'
      write(*,*)  '      >>>   Resummed pT-distribution    '//
     f         '<<<         '
      write(40,*) '      >>>   Resummed pT-distribution    '//
     f         '<<<'

      IF(order == 1) THEN
      write(*,*) '      >>>  '//
     f   '        at NLO+NLL           <<<'
      write(40,*)'      >>>  '//
     f   '        at NLO+NLL           <<<'
      ELSEIF(order == 2) THEN
      write(*,*) '      >>> '//
     f   '       at NNLO+NNLL          <<<'
      write(40,*)'      >>> '//
     f   '       at NNLO+NNLL          <<<'
      ELSE
         write(tmp1,'(i2)') order
         CALL printstop('bad parameter: "order = '//tmp1//'" not '
     f    //'accepted value')
      ENDIF

      write(*,*) ' '
      write(40,*)' '
      END

C-}}}

c$$$C-{{{ subroutine screenoutputsushi
c$$$
c$$$      subroutine screenoutputsushi()
c$$$
c$$$      implicit none
c$$$      character hepunit*10,bbhstring*3
c$$$
c$$$      include '../commons/common-inputoutput.f'
c$$$      !internal definitions
c$$$
c$$$!defined at other places:
c$$$!AlfasMZ,muRfactor,muFfactor,cme,dist,prefix,prefix2,pty,iset
c$$$!norder,mw,mc,ew,mz,mbmb,renscheme,mt,pseudo,tanbresum,pseudorap
c$$$      include '../commons/common-keys.f'
c$$$      include '../commons/common-slha.f'
c$$$      include '../commons/common-consts.f'
c$$$      include '../commons/common-vars.f'
c$$$      include '../commons/common-ren.f'
c$$$      include '../commons/common-quark.f'
c$$$      include '../commons/common-int.f'
c$$$
c$$$      bbhstring='bbh'
c$$$      if (lcchkey) bbhstring='cch'
c$$$
c$$$      if ((norderggh.eq.0).and.(ew.ge.1)) then
c$$$            write(*,105)
c$$$            write(*,*) 
c$$$     &"Note: At LO electroweak contributions for ggh are not given."
c$$$            write(*,105)
c$$$      endif
c$$$
c$$$      if (((dist.ge.1).or.(ptcut.or.rapcut)).and.(ew.eq.2)) then
c$$$            write(*,105)
c$$$            write(*,*) 
c$$$     &"Note: The SM electroweak factor is not applicable"
c$$$            write(*,*) "for cuts and distributions."
c$$$            write(*,105)
c$$$      endif
c$$$
c$$$      if (((dist.eq.1).or.(dist.eq.3).or.(ptcut))) then
c$$$            write(*,105)
c$$$            write(*,*) 
c$$$     &"Note: Fixed order p_T distribution (no resummation)!"
c$$$            write(*,*) "p_T < 20 GeV not reasonable."
c$$$            write(*,105)
c$$$      endif
c$$$
c$$$      if (norderggh.ge.2) then
c$$$         if (dist.ne.0) then
c$$$            write(*,105)
c$$$            write(*,*) 
c$$$     &"Note: Differential cross sections for ggh are not available ",
c$$$     &"at NNLO."
c$$$            write(*,*) 
c$$$     &"Thus only NLO results will be given."
c$$$            write(*,105)
c$$$         elseif (ptcut.or.rapcut) then
c$$$            write(*,105)
c$$$            write(*,*) 
c$$$     &"Note: Cuts can only be applied at NLO for ggh."
c$$$            write(*,*) 
c$$$     &"Thus NNLO weighted results will not be given."
c$$$            write(*,105)
c$$$         elseif (model.eq.1) then
c$$$            if(norderggh.eq.2) then
c$$$               write(*,105)
c$$$               write(*,*) 
c$$$     &"Note: NNLO SUSY contribution not taken into account."
c$$$               write(*,*) 
c$$$     &"Use order ggh = 3 for approximate NNLO stop cont. for h."
c$$$               write(*,105)
c$$$            else
c$$$               write(*,105)
c$$$               write(*,*) 
c$$$     &"Note: Using approximate NNLO top+stop contributions."
c$$$               write(*,*) 
c$$$            endif
c$$$         endif
c$$$      endif
c$$$      if (norderbbh.ge.0) then
c$$$         if (dist.gt.0) then
c$$$            write(*,105)
c$$$            write(*,*) 
c$$$     &           "Note: Differential cross sections for "//bbhstring/
c$$$     &           /" are not available."
c$$$            write(*,*) 
c$$$     &"However cuts for the total cross sections can be set!"
c$$$            write(*,105)
c$$$         endif
c$$$         if ((dist.eq.0).and.(norderbbh.eq.2)) then
c$$$         if (ptcut.or.rapcut) then
c$$$            write(*,105)
c$$$            write(*,*) 
c$$$     &"Note: Cuts can only be applied at NLO for "//bbhstring//"."
c$$$            write(*,*) 
c$$$     &"Thus NNLO results will not be given."
c$$$            write(*,105)
c$$$         endif
c$$$         endif
c$$$      end if
c$$$
c$$$      if ((dist.eq.0).or.(dist.eq.2)) then
c$$$         hepunit = "   pb"
c$$$      else
c$$$         hepunit = "   pb/GeV"
c$$$      end if
c$$$
c$$$      if (norderbbh.ge.0) then
c$$$         if (dist.eq.0) then
c$$$            write(*,105)
c$$$            write(*,107) " The "//bbhstring//" results are given by:"
c$$$            if ((ptc.eq.0).and.(rapc.eq.0)) then
c$$$            write(*,108) "LO: ",SUbbh(1)
c$$$            else
c$$$            write(*,106) "LO: ",SUbbh(1),SUbbherr(1),hepunit
c$$$            end if
c$$$            if (norderbbh.gt.0) then
c$$$               if ((ptc.eq.0).and.(rapc.eq.0)) then
c$$$               write(*,108) "NLO: ",SUbbh(2)
c$$$               else
c$$$               write(*,106) "NLO: ",SUbbh(2),SUbbherr(2),hepunit
c$$$               end if
c$$$            end if
c$$$            if (norderbbh.gt.1) then
c$$$            if (.not.((ptc.gt.0).or.(rapc.gt.0))) then
c$$$               write(*,108) "NNLO: ",SUbbh(3)
c$$$            end if
c$$$            end if
c$$$         end if
c$$$      end if
c$$$
c$$$      if (norderggh.ge.0) then
c$$$         write(*,105)
c$$$         write(*,107) " The ggh results are given by:"
c$$$         write(*,106) "LO: ",xsec(1),xsecerr(1),hepunit
c$$$         if (norderggh.gt.0) then
c$$$            write(*,106) "gg: ",ggchan,ggchanerr,hepunit
c$$$            write(*,106) "qg: ",qgchan, qgchanerr,hepunit
c$$$            write(*,106) "qq: ",qqchan, qqchanerr,hepunit
c$$$            write(*,106) "NLO: ",xsec(2),xsecerr(2),hepunit
c$$$!            if ((dist.eq.0).and.((ew.ge.1).or.(norderggh.ge.2))) then
c$$$            if (((ew.ge.1).or.(norderggh.ge.2))
c$$$     &.and.(((dist.eq.0).and.(rapc.eq.0).and.(ptc.eq.0)).or.(ew.eq.1)))
c$$$     & then
c$$$            write(*,106) "xsec: ",xeff,xefferr,hepunit
c$$$               write(*,107)
c$$$     &" Details with respect to the weighted result in output-file."
c$$$            end if
c$$$         end if
c$$$      end if
c$$$
c$$$      write(*,105)
c$$$
c$$$ 105  format('#--------------------------------------------------#')
c$$$ 106  format(a11,'    ',f10.5,'   +-',f10.5,a10)
c$$$ 107  format(a)
c$$$ 108  format(a11,'    ',f10.5, '   pb')
c$$$
c$$$      end
c$$$C-}}}

